# Contributing

We highly value and encourage contributions from the community!

Ignite is [Apache 2.0 licensed](LICENSE) and accepts contributions via GitHub Pull Requests.This document outlines some of the conventions on development workflow, commit message formatting, contact points and other resources to make it easier to get your contribution accepted.

We gratefully welcome improvements to documentation as well as to code.

## Community and Access

Join [weaveworks-ignite@googlegroups.com](https://groups.google.com/forum/#!forum/weaveworks-ignite) for calendar invites to calls and edit access to community documents.

We also hope to see you at our [developer meetings](https://docs.google.com/document/d/1fv8_WD6qXfvlIq7Bb5raCGyBvc42dNF-l8uaoZzoUYI/edit).

## Guidelines

TODO: Add contributing guidelines here after we formalize them.

## Make targets

To compile the `ignite` binary, run
```
make
```

To compile the `ignite-spawn` binary and build the Docker image, run
```
make ignite-spawn
```

Before submitting a PR, run
```
make tidy
```

Other targets:
- Install the `ignite` binary: `make install`
- (Re)generate autogenerated content: `make autogen`
- Generate dependency graph: `make graph`
  - Depends on `sfdp` (usually found in the `graphviz` package)
- Push the `weaveworks/ignite` Docker image: `make image-push`
